#ifndef AVL_H_
#define  AVL_H_


#include<stdio.h>
#include<stdlib.h>

#include "Tree.h"

// A utility function to right rotate subtree rooted with y
// See the diagram given above.
NodePointer rightRotate(NodePointer x);

// A utility function to left rotate subtree rooted with x
// See the diagram given above.
NodePointer leftRotate(NodePointer x);

// Get Balance factor of node N
int getBalance(NodePointer N);

NodePointer insert(NodePointer node, int key);

/* Given a non-empty binary search tree, return the
node with minimum key value found in that tree.
Note that the entire tree does not need to be
searched. */
NodePointer minValueNode(NodePointer node);

// Recursive function to delete a node with given key
// from subtree with given root. It returns root of
// the modified subtree.
NodePointer deleteNode(NodePointer root, int key);

#endif //AVL_H_
