#include "Tree.h"


/* Helper function that allocates a new node with the given key and
	NULL left and right pointers. */
NodePointer createNewNode(int key)
{
	NodePointer node = (TreeNode*) malloc(sizeof(TreeNode));
	node->data.key = key;
	node->leftChild = NULL;
	node->rightChild = NULL;
	node->height = 1; // new node is initially added at leaf
	return node;
}

// A utility function to get height of the tree
int getTreeHeight(NodePointer N)
{
	if (N == NULL)
		return 0;
	return N->height;
}

// A utility function to get maximum of two integers
int getMaxValue(int a, int b)
{
	return (a > b)? a : b;
}

//Show content of the node
void visitNode(NodePointer nodePointer)
{
    //printf("\n\t---Nó atual---\n");
    printf("Chave:%d\n", nodePointer->data.key);
    //printf("Nome:%s\n", nodePointer->data.name);
    //printf("Valor:%f\n", nodePointer->data.value);
}

//https://www.geeksforgeeks.org/print-binary-tree-2-dimensions/
// Function to print binary tree in 2D
// It does reverse inorder traversal
void print2DUtil(NodePointer root, int space)
{
    // Base case
    if (root == NULL)
        return;

    // Increase distance between levels
    space += COUNT;

    // Process right child first
    print2DUtil(root->leftChild, space);

    // Print current node after space
    // count
    printf("\n");
    for (int i = COUNT; i < space; i++)
        printf(" ");
    printf("Chave:%d\n", root->data.key);
    /*for (int i = COUNT; i < space; i++)
        printf(" ");
    printf("Nome:%s\n", root->data.name);*/
    /*for (int i = COUNT; i < space; i++)
        printf(" ");
    printf("Valor:%f\n", root->data.value);*/

    // Process left child
    print2DUtil(root->rightChild, space);
}

// Wrapper over print2DUtil()
void print2D(NodePointer root)
{
   // Pass initial space count as 0
   print2DUtil(root, 0);
}

//In order visit
void inOrderTreeVisit(NodePointer nodePointer) {
    if(nodePointer != NULL) {
        inOrderTreeVisit(nodePointer->leftChild);
        visitNode(nodePointer);
        inOrderTreeVisit(nodePointer->rightChild);
    }
}

//Pre order visit
void preOrderTreeVisit(NodePointer nodePointer){
     if(nodePointer != NULL){
         visitNode(nodePointer);
         preOrderTreeVisit(nodePointer->leftChild);
         preOrderTreeVisit(nodePointer->rightChild);
     }
 }

//Post order visit
void postOrderTreeVisit(NodePointer nodePointer){
    if(nodePointer != NULL){
        postOrderTreeVisit(nodePointer->leftChild);
        postOrderTreeVisit(nodePointer->rightChild);
        visitNode(nodePointer);
    }
}
