#ifndef TREE_H_
#define  TREE_H_

#include <stdlib.h>
#include <stdio.h>
#define COUNT 10

//Data of a node
typedef struct Data
{
    int key;
    float value;
    char* name;
    //Other data type for each node
} DataStruct;

typedef struct Node TreeNode;

typedef TreeNode* NodePointer;

//A node contains the data it must hold and pointer to children
struct Node{
    DataStruct data;
    NodePointer leftChild, rightChild;
    int height;
};

//Show content of the node
void visitNode(NodePointer nodePointer);
// A utility function to get height of the tree
int getTreeHeight(NodePointer N);
// A utility function to get maximum of two integers
int getMaxValue(int a, int b);

/* Helper function that allocates a new node with the given key and
	NULL left and right pointers. */
NodePointer createNewNode(int key);

void inOrderTreeVisit(NodePointer node);
void preOrderTreeVisit(NodePointer node);
void postOrderTreeVisit(NodePointer node);

int countNodes(NodePointer node);

//https://www.geeksforgeeks.org/print-binary-tree-2-dimensions/
// Function to print binary tree in 2D
// It does reverse inorder traversal
void print2D(NodePointer root);

#endif //TREE_H_
